src/Alecsia/AnnotationBundle/Entity/Fichier.php
<?php

namespace Alecsia\AnnotationBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Alecsia\AnnotationBundle\Lib\AlecsiaGlobals;

/**
 * Alecsia\AnnotationBundle\Entity\Fichier
 *
 * @ORM\Table(name="Fichier")
 * @ORM\Entity(repositoryClass="Alecsia\AnnotationBundle\Entity\FichierRepository")
 */
class Fichier {

   /**
    * @var integer $id
    *
    * @ORM\Column(name="id", type="integer")
    * @ORM\Id
    * @ORM\GeneratedValue(strategy="AUTO")
    */
   protected $id;

   /**
    * @var string $dossier
    *
    * @ORM\Column(name="dossier", type="string", length=255)
    */
   protected $dossier;

   /**
    * @var string $nom_fichier
    *
    * @ORM\Column(name="nom_fichier", type="string", length=255)
    */
   protected $nom_fichier;

   /**
    * @var string $langage
    *
    * @ORM\ManyToOne(targetEntity="Alecsia\AnnotationBundle\Entity\Langage")
    */
   protected $langage;

   /**
    * @var integer $taille
    *
    * @ORM\Column(name="taille", type="integer")
    */
   protected $taille;

   /**
    * @var boolean $exclus
    *
    * @ORM\Column(name="exclus", type="boolean")
    */
   protected $exclus;

   /**
    * @ORM\ManyToOne(targetEntity="Alecsia\AnnotationBundle\Entity\Rendu", inversedBy="fichiers", cascade={"persist"})
    */
   protected $rendu;

   /**
    * @pre $fichier is a regular file
    */
   public function __construct($dossier, $fichier, \Alecsia\AnnotationBundle\Entity\Rendu $rendu, \Alecsia\AnnotationBundle\Entity\Langage $langage, $exclus = false) {
      $this->dossier = $dossier;
      $this->nom_fichier = $fichier;

      if (!is_file($this->getCheminAbsolu())) {
         throw new \Exception("Chemin introuvable : " . $this->getCheminAbsolu());
      }

      $this->rendu = $rendu;
      $this->langage = $langage;
      $this->exclus = $exclus;

      // Calcul taille du fichier
      $this->taille = filesize($this->getCheminAbsolu());
   }

   public function exists() {
       return file_exists($this->getCheminAbsolu());
   }

   public function getUploadRootDir() {
      return AlecsiaGlobals::getUploadDir();
   }

   public function getCheminAbsolu() {
      return $this->getUploadRootDir() . "/" . $this->dossier . "/" . $this->nom_fichier;
   }

   /**
    * Ouvre le fichier et renvoie son contenu
    */
   public function getContenu() {
      $fichier = fopen($this->getCheminAbsolu(), "r");

      if (!$fichier) {
         throw new \Exception("Chemin introuvable : " . $this->getCheminAbsolu());
      }

      // On lit ligne par ligne le fichier
      $contenu = "";
      while (!feof($fichier)) {
         $contenu .= fgets($fichier);
      }

      fclose($fichier);

      return $contenu;
   }

   // Getters & Setters
   public function getId() {
      return $this->id;
   }

   public function getNomFichier() {
      return $this->nom_fichier;
   }

   public function getSousDossier() {
      return '/' . preg_replace('/^[0-9]+\/?/', '', $this->dossier);
   }

   public function getDossierRacine() {
      return '/' . preg_replace('/^([0-9]+)\/?.*$/', '$1', $this->dossier);
   }

   public function getTaille() {
      return $this->taille;
   }

   public function setExclus($exclus) {
      $this->exclus = $exclus;
   }

   public function isExclus() {
      return $this->exclus;
   }

   public function getRendu() {
      return $this->rendu;
   }

   public function setRendu(Rendu $rendu) {
      $this->rendu = $rendu;
   }

   public function getLangage() {
      return $this->langage;
   }

   public function setLangage($langage) {
      $this->langage = $langage;
   }

   // Helpers
   public function getSujet() {
      return $this->getRendu()->getSujet();
   }

   // ToString
   public function __toString() {
      return $this->getNomFichier();
   }

}

src/Alecsia/AnnotationBundle/Entity/Sujet.php
<?php

namespace Alecsia\AnnotationBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Alecsia\AnnotationBundle\Entity\Exceptions\RenduNonTermineException;
use Alecsia\AnnotationBundle\Entity\Exceptions\LectureSeuleException;

/**
 * Alecsia\AnnotationBundle\Entity\Sujet
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="Alecsia\AnnotationBundle\Entity\SujetRepository")
 */
class Sujet {

   const STATUS_WAIT = 'wait';
   const STATUS_MARK = 'mark';
   const STATUS_CONSULT = 'cnf';
   const STATUS_FROZEN = 'frozen';

   /**
    * @var integer $id
    *
    * @ORM\Column(name="id", type="integer")
    * @ORM\Id
    * @ORM\GeneratedValue(strategy="AUTO")
    */
   protected $id;

   /**
    * @var string $nom
    *
    * @ORM\Column(name="nom", type="string", length=255)
    */
   protected $nom;

   /**
    * @var boolean $is_TD
    *
    * @ORM\Column(name="is_TD", type="boolean")
    */
   protected $is_TD;

   /**
    * @var integer $note_sur
    *
    * @ORM\Column(name="note_sur", type="integer")
    */
   protected $note_sur;

   /**
    * @var integer $startAt
    * What should be the initial mark for the works
    * This is generally useful either to start from 0 or from
    * the maximal mark (ie. note_sur).
    * @ORM\Column(name="noteInitiale", type="integer")
    */
   protected $noteInitiale;

   /**
    * @var float $moyenne
    *
    * @ORM\Column(name="moyenne", type="float", nullable=true)
    */
   protected $moyenne;

   /**
    * @var enum $status
    *
    * status can have four different values
    * wait: waiting for all the works to be included, and waiting to start marking
    *       process;
    * mark: starting to mark works;
    * cnf:  consultable but not frozen yet -> works have been marked but can still
    *       be modified, works are consultable by students
    * frozen: marks are frozen: works can be consulted by students but can't be
    *         modified anymore
    *
    * @ORM\Column(name="status", type="string", columnDefinition="ENUM('wait','mark','cnf','frozen')")
    */
   protected $status = self::STATUS_WAIT;

   /**
    * @ORM\OneToOne(targetEntity="Alecsia\AnnotationBundle\Entity\ListeModeles", cascade={"persist", "remove"})
    */
   protected $liste_modeles;

   /**
    * @var UE
    * @ORM\ManyToOne(targetEntity="Alecsia\AnnotationBundle\Entity\UE", cascade={"persist"}, inversedBy="sujets")
    */
   protected $UE;

   /**
    * @ORM\OneToMany(targetEntity="Alecsia\AnnotationBundle\Entity\Rendu", mappedBy="sujet", cascade={"persist", "remove"})
    */
   protected $rendus;

   /**
    * @ORM\OneToMany(targetEntity="Alecsia\AnnotationBundle\Entity\Exercice", mappedBy="sujet", cascade={"persist", "remove"})
    */
   protected $exercices;

   /**
    * indicates the number of guts for lettre format 
    * if 0 value is shown as number else it will be shown as lettre 
    * @var type 
    * @ORM\Column(name="guts", type="integer")
    */
   protected $guts;

   function __construct($nom, $isTD = false, $status = self::STATUS_WAIT, $note_sur = 20, $noteInitiale = 0, $guts = 0) {
      $this->nom = $nom;
      $this->is_TD = $isTD;
      $this->status = $status;
      $this->note_sur = $note_sur;
      $this->noteInitiale = $noteInitiale;
      $this->guts = $guts;
   }

   /* ============================== */
   /* Students                       */
   /* ============================== */

   public function hasStudentWorkedOnIt(Student $student) {
      $workIsFromStudent = function($key, $work) use ($student) {
         return ($work instanceof Rendu) && ($work->hasStudent($student));
      };

      return $this->rendus->exists($workIsFromStudent);
   }

   // Getters & Setters
   public function getId() {
      return $this->id;
   }

   public function setNom($nom) {
      $this->assertGel();
      $this->nom = $nom;
   }

   public function getNom() {
      return $this->nom;
   }

   public function setIsTD($isTD) {
      $this->assertGel();
      $this->is_TD = $isTD;
   }

   public function getIsTD() {
      return $this->is_TD;
   }

   protected function setStatus($status) {
      $this->assertGel();
      $this->status = $status;
   }

   protected function getStatus() {
      return $this->status;
   }

   public function getNotesur() {
      return $this->note_sur;
   }

   public function setNotesur($note_sur) {
      $this->assertGel();
      $this->note_sur = $note_sur;
   }

   public function getListeModeles() {
      return $this->liste_modeles;
   }

   public function setListeModeles($liste_modeles) {
      $this->assertGel();
      $this->liste_modeles = $liste_modeles;
   }

   public function getRendus() {
      return $this->rendus;
   }

   public function getRendusRestants() {
      return $this->rendus->filter(function($rendu) {
                 return !($rendu->getTermine());
              });
   }

   public function getExercices() {
      return $this->exercices;
   }

   public function addExercice($exercice) {
      $this->assertGel();
      $this->exercices[] = $exercice;
      $exercice->setSujet($this);
   }

   /** @return UE */
   public function getUE() {
      return $this->UE;
   }

   public function setUE($UE) {
      $this->UE = $UE;
   }

   public function getMoyenne() {
      return $this->moyenne;
   }

   public function setMoyenne($moyenne) {
      $this->moyenne = $moyenne;
   }

   public function getNoteInitiale() {
      return $this->noteInitiale;
   }

   public function setNoteInitiale($noteInitiale) {
      $this->assertGel();
      $this->noteInitiale = $noteInitiale;
   }

   /*
    * Return an associative array whose key is a student identifier
    * and the value is the mark obtained.
    * @pre The marks must have been frozen.
    * @param group_id an array of group_ids, from which the marks must be taken.
    *                 the array can be null
    * @param all_marks: get all marks even if the subject is not frozen
    */

   public function getNotes($group_id = null, $all_marks = false) {
      $notes = array();
      if ($all_marks || $this->getStatus() == self::STATUS_FROZEN) {
         $rendus = $this->getRendus();

         foreach ($rendus as $rendu) {
            $etudiants = $rendu->getStudents();
            foreach ($etudiants as $etu) {
               if (!$group_id || in_array($rendu->getGroup()->getId(), $group_id)) {
                  $notes[] = array('student' => $etu, 'note' => $rendu->getNote(),
                      'group' => $rendu->getGroup());
               }
            }
         }
      }
      return $notes;
   }

   public function isFrozen() {
      return $this->getStatus() == self::STATUS_FROZEN;
   }

   public function isWaiting() {
      return $this->getStatus() == self::STATUS_WAIT;
   }

   public function isConsultable() {
      return (bool) ($this->getStatus() == self::STATUS_CONSULT || $this->getStatus() == self::STATUS_FROZEN);
   }

   public function isMarking() {
      return $this->getStatus() == self::STATUS_MARK;
   }

   /**
    * Does the mark can be displayed?
    * For the moment it is equivalent to the work is consultable
    * but the two events could be dissociated.
    */
   public function isMarkDisplayable() {
      return $this->isConsultable();
   }

   public function setFrozen() {
      $this->setStatus(self::STATUS_FROZEN);
   }

   public function setWaiting() {
      $this->setStatus(self::STATUS_WAIT);
   }

   public function setConsultable() {
      $this->setStatus(self::STATUS_CONSULT);
   }

   public function setMarking() {
      $this->setStatus(self::STATUS_MARK);
   }

   public function setMarkDisplayable() {
      $this->setStatus(self::STATUS_REVEAL_MARK);
   }

   // ToString
   public function __toString() {
      return "(" . $this->getId() . ") " . $this->getNom();
   }

   // Renvoie vrai ssi tous les rendus sont marqués comme terminés.
   public function tousTermines() {
      $toustermines = true;
      foreach ($this->rendus as $rendu) {
         $toustermines &= $rendu->getTermine();
      }
      return $toustermines;
   }

   // Assure que le rendu est modifiable
   public function assertGel() {
      if ($this->getStatus() == self::STATUS_FROZEN) {
         throw new LectureSeuleException();
      }
   }

   /* =============
     = Mutateurs =
     ============= */

   // Marque tous les rendus comme terminés
   public function toutTerminer() {
      foreach ($this->rendus as $rendu) {
         $rendu->setTermine(true);
      }
   }

   // Gele tous les rendus
   // Throws RenduNonTermineException
   public function geler() {
      if (!$this->tousTermines()) {
         throw new RenduNonTermineException();
      }

      foreach ($this->rendus as $rendu) {
         $rendu->geler();
      }

      $this->setFrozen();
   }

   /* =========
     = Copie =
     ========= */

   // Renvoie un nouveau sujet identique à celui ciisLettre()
   // à l'exception près des rendus.
   public function cloner($ue) {
      // Nouveau sujet
       $new_sujet = new Sujet($this->getNom(), $this->getIsTD(), self::STATUS_WAIT, $this->getNotesur(), $this->getNoteInitiale(), $this->getSubjectGuts());

      // Copie des exercices
      $old_exs = $this->getExercices();
      foreach ($old_exs as $old_ex) {
         $new_ex = $old_ex->cloner($new_sujet);
         $new_sujet->addExercice($new_ex);
      }

      // Copie de la liste de modèles
      $new_lm = $this->getListeModeles()->cloner($new_sujet->getExercices());
      $new_sujet->setListeModeles($new_lm);
      // Set UE
      $new_sujet->setUE($ue);


      return $new_sujet;
   }

   public function getSubjectGuts() {
      return $this->guts;
   }

   public function setSubjectGuts($guts_number) {
      $this->guts = $guts_number;
   }

   public function isLettre() {
      return $this->getSubjectGuts() !== 0;
   }

}

src/Alecsia/AnnotationBundle/Controller/Correction/ModeleChooserController.php
<?php

namespace Alecsia\AnnotationBundle\Controller\Correction;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use Symfony\Component\HttpFoundation\Response;
use Alecsia\AnnotationBundle\Controller\AlecsiaController;
use Alecsia\AnnotationBundle\Entity\Modele;
use Alecsia\AnnotationBundle\Controller\Preferences\ListeModelesGlobaleController;

class ModeleChooserController extends AlecsiaController {
   /* Renvoie la liste de modèles à proposer en fonction du sujet */

   public function getModelesAction($sujet_id) {

      // Recup BDD du sujet
      $em = $this->getDoctrine()->getManager();
      $sujet = $em->getRepository("AnnotationBundle:Sujet")->findOneById($sujet_id);

      if (!$sujet) {
         throw new NotFoundHttpException(sprintf('Sujet #%s introuvable.', $rendu_id));
      }

      // Recup exo prioritaire
      $exoprior = $this->getRequest()->request->get("exercice_id");

      $modeles = $this->ModelService()->getInterestingModels($sujet, $exoprior);

      /* Get global models */
      $listemodelesGlobaux = $this->ModelListService()
              ->getGlobalList($this->getUser());
      $modeles = array_merge($modeles, $listemodelesGlobaux->getModeles()->toArray());

      $modeles_json = $this->ModelService()
              ->getJsons($modeles, $this, "AnnotationBundle:Correction:Modele/modeletochoose.html.twig");


      // Ajout des options par défaut
      $dataforview = array("abbrev" => "nc", "nom" => "Nouvelle annotation");
      $modeles_json[] = $this->ModelService()
              ->getAbstractJson($this->renderView('AnnotationBundle:Correction:Modele/nouveaucontenu.html.twig', $dataforview), "Nouveau contenu", $dataforview["nom"], $exoprior, -1, "fma_nom", true, false);

      $dataforview = array("abbrev" => "nc", "nom" => "Nouveau modèle dans \"" . $sujet->getNom() . "\"");

      $modeles_json[] = $this->ModelService()
              ->getAbstractJson($this->renderView('AnnotationBundle:Correction:Modele/nouveaucontenu.html.twig', $dataforview), "Nouveau contenu", $dataforview["nom"], $exoprior, -1, "fma_nom", true, false, $sujet->getListeModeles()->getId());

      $dataforview = array("abbrev" => "nc", "nom" => "Nouveau modèle dans \"" . $sujet->getUE()->getNomCourt() . "\"");
      $modeles_json[] = $this->ModelService()
              ->getAbstractJson($this->renderView('AnnotationBundle:Correction:Modele/nouveaucontenu.html.twig', $dataforview), "Nouveau contenu", $dataforview["nom"], -1, -1, "fma_nom", true, true, $sujet->getUE()->getModelList()->getId());

      $dataforview = array("abbrev" => "nc", "nom" => "Nouveau modèle global");
      $modeles_json[] = $this->ModelService()
              ->getAbstractJson($this->renderView('AnnotationBundle:Correction:Modele/nouveaucontenu.html.twig', $dataforview), "Nouveau contenu", $dataforview["nom"], -1, -1, "fma_nom", true, true, $listemodelesGlobaux->getId());

      // Encodage JSON
      $modeles_json = json_encode($modeles_json);

      return new Response($modeles_json);
   }

   private function ModelListService() {
      return $this->get('alecsia.modelListService');
   }

   private function ModelService() {
      return $this->get('alecsia.modeleService');
   }

}

src/Alecsia/AnnotationBundle/Resources/views/Correction/correction.html.twig
{# Ressources dispo :
   * rendu
   * fichiers
   * liste_annotations
   * exercices
   #}


{% import 'AnnotationBundle:macros:users.html.twig' as user %}

{% extends 'AnnotationBundle::layout.html.twig' %}

{% block titre %}
   {{rendu.nom}} - {{ parent() }}
{% endblock %}

{% block body %}

   {% if not(lectureseule) %}
      {% include 'AnnotationBundle:Correction:Fichier/manageAnnotForm.html.twig' %}
      {% include 'AnnotationBundle:Correction:Fichier/manageFichiers.html.twig' %}
      {% include 'AnnotationBundle:Correction:Students/addStudentForm.html.twig' with {'work': rendu} only%}


      {% set lsclass = "" %}
   {% else %}
      {% set lsclass = "lectureseule" %}
   {% endif %}

   {% if not(lectureetudiant) %}
      {% include 'AnnotationBundle:Dashboard:Etudiants/mailForm.html.twig' with {etudiants:rendu.students, ue: rendu.sujet.ue, rendu: rendu, type: "custom"} only %}
      {% include 'AnnotationBundle:Dashboard:Etudiants/mailForm.html.twig' with {etudiants:rendu.students, ue: rendu.sujet.ue, rendu: rendu, type: "rendu"} only %}
      {% include 'AnnotationBundle:Correction:Students/manageStudentsForm.html.twig' with {'work': rendu} only%}
   {% endif %}



<div id="btn-top-page"></div>
   <div id="correctionUI" class="{{lsclass}}">
      {# En tête #}
      <div class="header">

         {% if not(lectureetudiant) %}
            <div class="barre_outils gauche">
               <a href="{{ path('AnnotationBundle_sujet', {'sujet_id': rendu.sujet.id, 'group_id' : rendu.group.id}) }}" class="bouton retour">Retour au sujet</a> 
               <a href="{{ path('AnnotationBundle_terminerRendu', {'rendu_id': rendu.id}) }}" class="bouton retour" id="end_correction_top_button">Terminer la correction</a>
            </div>
         {% else %}
            <div class="barre_outils gauche">
               <a href="{{ path('AlecsiaStudentHome')}}" class="bouton retour">Retour à mes travaux</a>
            </div>
         {% endif %}

         <div class="infos">
            {% if rendu.students is not empty %}
               <h2>
                  {% for etu in rendu.students %}
                     <span class="studentName">{{user.displayUserName(etu)}}</span>
                  {% endfor %}
               </h2>
            {% endif %}
            <h1>
               {{rendu.nom}}
            </h1>

         </div>
         {% if lectureseule and not lectureetudiant %}
            <div class="infogel">
               <p class="state">
                  <span class="ico ico_gel rounded"></span>
                  <strong>Rendu gelé</strong>
               </p>
            </div>
         {% endif %}
         {% if not(lectureseule) %}
            <div class="barre_outils">
               <button class="bouton bleu" id="bouton_annoter">Annoter le rendu</button>
            </div>
         {% endif %}

         <div class="barre_outils droite">
            {% if rendu.sujet.exercices is empty %}
               {% include 'AnnotationBundle:Correction:Bareme/noBareme.html.twig' %}
            {% elseif not(lectureetudiant) or (rendu.sujet.markDisplayable)  %}
               {% include 'AnnotationBundle:Correction:Bareme/bareme.html.twig' %}
            {% else %}
               {% include 'AnnotationBundle:Correction:Bareme/waitingForBareme.html.twig' %}
            {% endif %}

            {% if not lectureetudiant %}
               <button class="bouton action_dd">Réglages <span class="triangle-down-gf"></span></button>
               <div class="panel_dd right">
                  <ul class="liste_choix grand">
                     {% if not(lectureseule) %}
                        <li><a href="#" class="go_modal_manage_fichiers">Gestion des fichiers</a></li>
                        {% endif %}
                     <li><a href="#" class="go_modal_manage_students">Gestion des étudiants</a></li>
                        {% if not(lectureseule) %}
                        <li><a href="#" accesskey="i" class="go_modal_add_student">Étudiants non inscrits</a></li>
                        {% endif %}
                  </ul>
               </div>
            {% endif %}
         </div>


      </div>

      <div class="contenu">

         <hr class="clear"/>

         {% if liste_annotations["entete"] is defined %}
            {% set hidden = "" %}
         {% else %}
            {% set hidden = "hidden" %}
         {% endif %}

         <div class="widget beige {{hidden}}" id="ap_entete">
            <div class="header">
               <h3>Remarques générales</h3>
            </div>
            <div class="contenu">
               <ul id="ap_0" >
                  {% if liste_annotations["entete"] is defined %}
                     {% for a in liste_annotations["entete"] %}
                        {% include 'AnnotationBundle:Correction:Fichier/annotation.html.twig' %}
                     {% endfor %}
                  {% endif %}
               </ul>
            </div>
            <hr class="clear"/>
         </div>


         {% set folder = '' %}
         {% set fichiersAffiches = 0 %}
         {% set targetNumber = 1 %} {#target number is the number of files plus the number of folders #}

         {% for fichier in fichiers %}
            {# Titre du dossier #}
            {% if not(fichier.exclus) and fichier.sousDossier != folder %}
               {% set folder = fichier.sousDossier %}
               <h2 id="target{{ targetNumber }}" class="folder">{{folder}}</h2>
               {% set targetNumber = targetNumber + 1 %}
            {% endif %}

            {% if not(fichier.exclus) %}
               {% set fichiersAffiches =  fichiersAffiches + 1 %}

               {% set annotations = liste_annotations[fichier.id]%}
               <span id="target{{ targetNumber }}"></span>
               {% include 'AnnotationBundle:Correction:Fichier/fichier.html.twig' %}
               {% set targetNumber = targetNumber + 1 %}
            {% endif %}
         {% endfor %}

         {% if fichiersAffiches == 0 %}

            <div class="fichier">
               <div class="fichier_panel">
                  <div class="widget">
                     <div class="vide">

                        <p class="header">Rendu vide</p>
                        {% if not(lectureetudiant) %}
                           <p class="contenu">
                              <button class="bouton go_modal_manage_fichiers">Gérer les fichiers</button>
                           </p>
                        {% endif %}
                     </div>
                  </div>
               </div>

            </div>

         {% else %}
            <div id="toc">
               <span id="index"> I N D E X </span>
               <div>
                  {% set folder = '' %}
                  {% set targetNumber = 1 %} 
                  {% for fichier in fichiers %}
                     {% if not(fichier.exclus) %}
                        {% if fichier.sousDossier != folder %}
                           {% set folder = fichier.sousDossier %}
                           <div class="toc_folder"><a href="#target{{ targetNumber }}">{{folder}}</a></div>
                              {% set targetNumber = targetNumber + 1 %}
                           {% endif %}
                        <div class="toc_file"><a href="#target{{ targetNumber }}">{{fichier.nomFichier}}</a></div>
                           {% set targetNumber = targetNumber + 1 %}
                        {% endif %}
                     {% endfor %}
               </div>
            </div>
         {% endif %}
               <!-- Arrow go up-->
               <div class="btn-top-page">
                   <a href="#btn-top-page">
                       <svg viewBox="0 0 640 380">
                           <path id="svg_1" d="m374.67746,210.3616l102.00284,-156.03929l101.99719,156.03929l-50.9989,0l0,156.79141l-101.99643,0l0,-156.79141l-51.0047,0z"/>
                       </svg>
                   </a>
               </div>


         {% if not(lectureetudiant) %}
            {% if not(rendu.termine) %}
               <div class="widget options_fin">
                  <a href="{{ path('AnnotationBundle_terminerRendu', {'rendu_id': rendu.id}) }}" class="bouton beige L fluid">Marquer le rendu comme terminé</a>
               </div>
            {% else %}
               <div class="widget options_fin">
                  <a href="{{ path('AnnotationBundle_sujet', {'sujet_id': rendu.sujet.id, 'group_id' : rendu.group.id}) }}" class="bouton beige L fluid">Retour au sujet</a>
               </div>
            {% endif %}
         {% endif %}
      </div>

   </div>
{% endblock %}

{% block modals %}

{% endblock %}

{# CSS #}
{% block css %}
   {{ parent() }}

   {# Coloration syntaxique #}
   {% stylesheets '@HighlightBundle/Resources/public/*.css' output='css/a.css' %}
   <link href="{{ asset_url }}" type="text/css" rel="stylesheet" />
   {% endstylesheets %}

   {# UI #}
   <link href="{{ asset('bundles/annotation/css/correction.css') }}" type="text/css" rel="stylesheet" />
{% endblock %}

{# Javascripts #}
{% block javascripts %}
   {{ parent() }}

   <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/AnnotPosManager.js') }}"></script>
   <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/LiaisonsManager.js') }}"></script>
   <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/HighlightingManager.js') }}"></script>
   <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/AnnotationList.js') }}"></script>
   <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/AnnotationEnTeteList.js') }}"></script>
    <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/ShortCutsKeys.js') }}"></script>
   {% if not(lectureseule) %}
    <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/ExercisesGrades.js') }}"></script>
      <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/AnnotationFormManager.js') }}"></script>
      <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/BoutonAnnoter.js') }}"></script>
      <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/SelectionManager.js') }}"></script>
      <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/BaremeManager.js') }}"></script>
      <script type="text/javascript" src="{{ asset('bundles/annotation/js/Correction/ModeleChooser.js') }}"></script>
      <script type="text/javascript" src="{{ asset('bundles/annotation/js/UIElements/formSubmission.js') }}"></script>
    {% endif %}

{% endblock %}